/***********************************************************************/
/*	creatfil.c                                                    */
/***********************************************************************/
#ifdef _C86_BIG
#define LPTR 1
#endif

/* create a file */
creatfil(pname,attrib,handle)
char *pname; /* pointer to full path name (ASCIIZ) string of filename */
int attrib;  /* attribute to be assigned to file */
unsigned *handle; /* 16 bit handle returned and used by other functions */
{
  struct intregs regs; /* registers for gdosint    */
  int ret_code,int_no;        /* return code and interrupt for gdosint */
 

#ifdef LPTR
			/* if big data models => get segment part of */
			/*     ASCII string address pointer          */
  regs.ds= hiword(pname);

#else

  regs.ds=0;		/* else => use default DS */

#endif

  regs.es=0;   /* default value for registers */
  regs.dh= (unsigned) (pname) >> 8; /* put pname address into dx register */
  regs.dl= (unsigned) (pname) - (regs.dh << 8);
  regs.ch= attrib >> 8; /* attribute goes into cx register */
  regs.cl = attrib - (regs.ch << 8);
  regs.ah=0x3C; /* DOS function number */
  int_no=0x21; /* interrupt number for DOS function call */
  ret_code = gdosint(int_no,&regs,&regs);
  *handle = (regs.ah << 8) + regs.al;  /* handle returned in ax register */
  return(ret_code);
}
