/***********************************************************************/
/*	getdrive.c                                                    */
/***********************************************************************/

/*   get the system default drive number                                    */
getdrive(drive)
int *drive;  /* the drive number (0 = A, 1 = B, etc.)                       */
{
  struct intregs regs; /* registers for gdosint    */
  int ret_code,int_no;        /* return code and interrupt for gdosint */

  regs.ds=regs.es=0;   /* default value for registers */
  regs.ds=0;   /* default value for registers */
  regs.ah=0x19; /* DOS function number */
  int_no=0x21; /* interrupt number for DOS function call */
  ret_code = gdosint(int_no,&regs,&regs);
  *drive=regs.al;
  return(ret_code);
}
