/***********************************************************************/
/*	grtrig.c                                                      */
/***********************************************************************/

/* function to produce sin,cos and tan numbers */
float grtrig(a,sct)
int a; /* angle */
int sct; /* indicator for trig: 1 = cos, 0 = sin */
{
float s,c,t; /* sin,cos,tan values */
int ang; /* adjusted angle */
float sign; /* values sign */
if((a < 0)||(a > 360)) return(-1);
/* adjust angle to be 0 to 90 */
if (a < 90)
  {
  ang = a;
  sign = 1.00;
  }
  else if(a < 180)
    {
    ang = 180 - a;
    if(sct == 0) sign = 1.00;
      else sign = -1.00;
    }
    else if( a < 270)
      {
      ang = a - 180;
      sign = -1.00;
      }
      else
        {
        ang = 360 - a;
        if(sct == 0) sign = -1.00;
          else sign = 1.00;
        }
switch(ang)
  {
  case 0:  s = 0.00; c = 1.00; break;
  case 1:  s = 0.02; c = 1.00; break;
  case 2:  s = 0.03; c = 1.00; break;
  case 3:  s = 0.05; c = 1.00; break;
  case 4:  s = 0.07; c = 1.00; break;
  case 5:  s = 0.09; c = 1.00; break;
  case 6:  s = 0.10; c = 0.99; break;
  case 7:  s = 0.12; c = 0.99; break;
  case 8:  s = 0.14; c = 0.99; break;
  case 9:  s = 0.16; c = 0.99; break;
  case 10: s = 0.17; c = 0.98; break;
  case 11: s = 0.19; c = 0.98; break;
  case 12: s = 0.21; c = 0.98; break;
  case 13: s = 0.22; c = 0.97; break;
  case 14: s = 0.24; c = 0.97; break;
  case 15: s = 0.26; c = 0.97; break;
  case 16: s = 0.28; c = 0.96; break;
  case 17: s = 0.29; c = 0.96; break;
  case 18: s = 0.31; c = 0.95; break;
  case 19: s = 0.33; c = 0.95; break;
  case 20: s = 0.34; c = 0.94; break;
  case 21: s = 0.36; c = 0.93; break;
  case 22: s = 0.37; c = 0.93; break;
  case 23: s = 0.39; c = 0.92; break;
  case 24: s = 0.41; c = 0.91; break;
  case 25: s = 0.42; c = 0.91; break;
  case 26: s = 0.44; c = 0.90; break;
  case 27: s = 0.45; c = 0.89; break;
  case 28: s = 0.47; c = 0.88; break;
  case 29: s = 0.48; c = 0.87; break;
  case 30: s = 0.50; c = 0.87; break;
  case 31: s = 0.52; c = 0.86; break;
  case 32: s = 0.53; c = 0.85; break;
  case 33: s = 0.54; c = 0.84; break;
  case 34: s = 0.56; c = 0.83; break;
  case 35: s = 0.57; c = 0.82; break;
  case 36: s = 0.59; c = 0.81; break;
  case 37: s = 0.60; c = 0.80; break;
  case 38: s = 0.62; c = 0.79; break;
  case 39: s = 0.63; c = 0.78; break;
  case 40: s = 0.64; c = 0.77; break;
  case 41: s = 0.66; c = 0.75; break;
  case 42: s = 0.67; c = 0.74; break;
  case 43: s = 0.68; c = 0.73; break;
  case 44: s = 0.69; c = 0.72; break;
  case 45: s = 0.71; c = 0.71; break;
  case 46: s = 0.72; c = 0.69; break;
  case 47: s = 0.73; c = 0.68; break;
  case 48: s = 0.74; c = 0.67; break;
  case 49: s = 0.75; c = 0.66; break;
  case 50: s = 0.77; c = 0.64; break;
  case 51: s = 0.78; c = 0.63; break;
  case 52: s = 0.79; c = 0.62; break;
  case 53: s = 0.80; c = 0.60; break;
  case 54: s = 0.81; c = 0.59; break;
  case 55: s = 0.82; c = 0.57; break;
  case 56: s = 0.83; c = 0.56; break;
  case 57: s = 0.84; c = 0.54; break;
  case 58: s = 0.85; c = 0.53; break;
  case 59: s = 0.86; c = 0.52; break;
  case 60: s = 0.87; c = 0.50; break;
  case 61: s = 0.87; c = 0.48; break;
  case 62: s = 0.88; c = 0.47; break;
  case 63: s = 0.89; c = 0.45; break;
  case 64: s = 0.90; c = 0.44; break;
  case 65: s = 0.91; c = 0.42; break;
  case 66: s = 0.91; c = 0.41; break;
  case 67: s = 0.92; c = 0.39; break;
  case 68: s = 0.93; c = 0.37; break;
  case 69: s = 0.93; c = 0.36; break;
  case 70: s = 0.94; c = 0.34; break;
  case 71: s = 0.95; c = 0.33; break;
  case 72: s = 0.95; c = 0.31; break;
  case 73: s = 0.96; c = 0.29; break;
  case 74: s = 0.96; c = 0.28; break;
  case 75: s = 0.97; c = 0.26; break;
  case 76: s = 0.97; c = 0.24; break;
  case 77: s = 0.97; c = 0.22; break;
  case 78: s = 0.98; c = 0.21; break;
  case 79: s = 0.98; c = 0.19; break;
  case 80: s = 0.98; c = 0.17; break;
  case 81: s = 0.99; c = 0.16; break;
  case 82: s = 0.99; c = 0.14; break;
  case 83: s = 0.99; c = 0.12; break;
  case 84: s = 0.99; c = 0.10; break;
  case 85: s = 1.00; c = 0.09; break;
  case 86: s = 1.00; c = 0.07; break;
  case 87: s = 1.00; c = 0.05; break;
  case 88: s = 1.00; c = 0.03; break;
  case 89: s = 1.00; c = 0.02; break;
  case 90: s = 1.00; c = 0.00; break;
  }
if( sct == 0) return(s * sign);
  else return(c * sign);
}
