/***********************************************************************/
/*	getkeycl.c                                                    */
/***********************************************************************/


getkeycl(charin) /* clear keyboard buffer then console input without echo */
int *charin; /* scan code returned to caller */
{
  struct intregs regs; /* registers for gdosint    */
  int ret_code,int_no;        /* return code and interrupt for gdosint */

  regs.es=regs.ds=0;   /* default value - no changes to register */
  regs.ah=0xC;  /* clear keyboard buffer and perform function in al */
  regs.al=8;    /* console input without echo */
  int_no=0x21; /* DOS function call */  
  ret_code = gdosint(int_no,&regs,&regs);
  if (regs.al == 0 ) /* if it is an extended code, call again for scan code */
     {
       regs.ah=8;    /* console input without echo */
       int_no=0x21; /* DOS function call */
       ret_code = gdosint(int_no,&regs,&regs);
       *charin=regs.al;
       return(1);
     }
  else
     {
       *charin=regs.al;
       return(0);
  }
}

