/***********************************************************************/
/*	daysfrom.c                                                    */
/***********************************************************************/

/* function to return a new date from a date & a # of days to be added */
daysfrom(out,year,month,day,numdays,convert)
char *out; /* output (target) string */
int year; /* year passed */
int month; /* month passed */
int day; /* day passed */
int numdays; /* number of days to add */
int convert; /* conversion code (see strdate function) */
{
int y1; /* century part of the year */
int y2; /* remaining part of the year */
int m1; /* month part to pass to strdate */
int mdays[13]; /* array to store # of days in each month */
int d1; /* day part to pass to strdate */
int n; /* temp variable for leap year added day */
int j; /* temp variable for processing # of days */
int y3; /* year part to pass strdate */
int k; /* temp variable to be used for incrementing */
int l; /* temp variable for limit on for-loop counter */
j = dayofweek(year,month,day);
if(j == 0) return(-2);
/* determine # of days in the year */
if(year > 100)
  {
  y1 = year / 100;
  y2 = year % 100;
  }
  else 
  {
  y1 = 19;
  y2 = year;
  }
m1 = month;
/* set up month array */
mdays[1] = 31;
mdays[2] = 28;
mdays[3] = 31;
mdays[4] = 30;
mdays[5] = 31;
mdays[6] = 30;
mdays[7] = 31;
mdays[8] = 31;
mdays[9] = 30;
mdays[10] = 31;
mdays[11] = 30;
mdays[12] = 31;
d1 = -1;
j = numdays;
if(numdays == 0) goto end;
if(numdays < 0) k = -1;
  else k = 1;
/* start leaping thru */
for( ; ; )
  {
  /* get thru rest of the month */
  if(m1 == 2)
    {
    if(y2 == 0)
      {
      if((y1 % 4) == 0) n = 2;
        else n = 1;
      }
      else
      {
      if((y2 % 4) == 0) n = 2;
        else n = 1;
      }
    }
    else n = 1;
  if(k == 1) l = mdays[m1] + n;
    else l = 0;
  /* set day variable */
  if(d1 == -1) d1 = day + k;
    else if(k == 1) d1 = 1;
            else d1 = mdays[m1] + n - 1;
  for( ; d1 != l; d1 = d1 +k)
    {
    j = j - k;
    if(j == 0) break;
    }
  if(j == 0) break;
  /* reset month and year if necessary */
  m1 = m1 + k;
  if((m1 == 13) || (m1 == 0))
    {
    m1 = m1 - (12 * k);
    y2 = y2 + k;
    if((y2 == 100)||( y2 == -1))
      {
      y2 = y2 - (100 * k);
      y1 = y1 + k;
      }
    }
  continue;
  }
/* call date routine to put date in correct format */
end:
y3 = (y1 * 100) + y2;
j = strdate(out,y3,m1,d1,convert);
if(j < 0) return(-1);
return(0);
}
