/***********************************************************************/
/*	strcvt.c                                                      */
/***********************************************************************/

/* function to do a general string conversion */
char *strcvt(ins,convert)
char *ins; /* source string to be converted */
int convert; /* conversion code to be used */
             /*   1 - remove all blanks */
             /*   2 - remove all non alpha characters */
             /*   4 - remove all non numeric characters */
             /*   8 - remove all leading blanks */
             /*  16 - remove all trailing blanks */
             /*  32 - convert multiple blanks to a single blank */
             /*  64 - convert lower case characters to upper */
             /* 128 - convert upper case alpha characters to lower */
{
char out[5000]; /* resultant string */
char code[8]; /* temp array to store what should be converted */
char blank; /* temp flag to signal if previous char was a blank */
int j; /* temp counter */
int i; /* temp counter */
int k; /* temp counter */
/* set up code array, i.e. what is needed to be done */
i = 256;
for(j = 7; j > -1; --j)
  {
  i = i/2;
  if(convert >= i)
    {
    code[j] = 'y';
    convert = convert - i;
    }
    else code[j] = 'n';
  }
/* set output string to input string */
for(i = 0; i < 5000; ++i)
  {
  out[i] = ins[i];
  if(ins[i] == '\0') break;
  }
/* check to remove all blanks */
if(code[0] == 'y')
  {
  k = -1;
  for(j = 0; j < i; ++j)
    {
    if(out[j] != ' ') out[++k] = out[j];
    }
  out[++k] = '\0';
  i = k;
  }
/* check to remove all non alpha characters (except blanks) */
if(code[1] == 'y')
  {
  k = -1;
  for(j = 0; j < i; ++j)
    {
    if((out[j]>96&&out[j]<123)||(out[j]>64&&out[j]<91)||(out[j]==' '))
      {
      out[++k] = out[j];
      }
    }
  out[++k] = '\0';
  i = k;
  }
/* check to remove all non numeric characters (except blanks) */
if(code[2] == 'y')
  {
  k = -1;
  for(j = 0; j < i; ++j)
    {
    if((out[j] > 47)&&(out[j] < 58)||(out[j] == ' '))
      {
      out[++k] = out[j];
      }
    }
  out[++k] = '\0';
  i = k;
  }
/* check to remove all leading blanks */
if(code[3] == 'y')
  {
  k = -1;
  for(j = 0; j < i; ++j)
    {
    if((out[j] == ' ') && (k == -1)) continue;
    out[++k] = out[j];
    }
  out[++k] = '\0';
  i = k;
  }
/* check to remove all trailing blanks */
if(code[4] == 'y')
  {
  for(j = i - 1; j != 0; --j)
    {
    if(out[j] != ' ')break;
    }
  out[++j] = '\0';
  i = j;
  }
/* check to convert multiple blanks to a single blank */
if(code[5] == 'y')
  {
  k = -1;
  blank = 'n';
  for(j = 0; j < i; ++j)
    {
    if(out[j] == ' ')
      {
      if(blank == 'n')
        {
        blank = 'y';
        out[++k] = out[j];
        continue;
        }
        else continue;
      }
      else
      {
      blank = 'n';
      out[++k] = out[j];
      }
    }
  out[++k] = '\0';
  i = k;
  }
/* check to convert lower case alpha to upper case alpha */
if(code[6] == 'y')
  {
  for(j = 0; j < i; ++j)
    {
    if((out[j] > 96)&&(out[j] < 123))
      {
      out[j] = out[j] - 32;
      }
    }
  }
/* check to convert upper case alpha to lower case alpha */
if(code[7] == 'y')
  {
  for(j = 0; j < i; ++j)
    {
    if((out[j] > 64) && (out[j] < 91))
      {
      out[j] = out[j] + 32;
      }
    }
  }
return(&out[0]);
}
