/***********************************************************************/
/*	strtime.c                                                     */
/***********************************************************************/

/* function to convert 4 integers to a specified time format */
strtime(out,hour,minute,sec,dec,convert)
char *out; /* output (target) string */
int hour; /* hour to be converted */
int minute; /* minute to be converted */
int sec; /* second to be converted */
int dec; /* decimal second to be converted */
int convert; /* conversion code to be used */
             /*  1 - hhmm                  */
             /*  2 - hrmm                  */
             /*  3 - hhmmss                */
             /*  4 - hrmmss                */
             /*  5 - hhmmssdd              */
             /*  6 - hrmmssdd              */
             /*  7 - hh:mm                 */
             /*  8 - hr:mm                 */
             /*  9 - hh:mm:ss              */
             /* 10 - hr:mm:ss              */
             /* 11 - hh:mm:ss:dd           */
             /* 12 - hr:mm:ss:dd           */
             /* 13 - hh:mm:ss.dd           */
             /* 14 - hr:mm:ss.dd           */
             /* 15 - hrmm pp               */
             /* 16 - hrmmss pp             */
             /* 17 - hrmmssdd pp           */
             /* 18 - hr:mm pp              */
             /* 19 - hr:mm:ss pp           */
             /* 20 - hr:mm:ss:dd pp        */
             /* 21 - hr:mm:ss.dd pp        */
{
char hs[4]; /* hour part of string */
char ms[4]; /* minute part of string */
char ss[4]; /* second part of string */
char ds[4]; /* decimal second part of string */
char pp[3]; /* am or pm part of string */
char colon; /* colon flag */
int j; /* temp integer variable */
/* check that all inputs are in range */
if((convert < 1) || (convert > 21)) return(-1);
if((hour < 0) || (hour > 23)) return(-2);
if((minute < 0) || (minute > 59)) return(-3);
if((sec < 0) || (sec > 59)) return(-4);
if((dec < 0) || (dec > 99)) return(-5);
/* convert hour */
pp[0] = '\0';
if(hour > 11) strcpy(pp,"PM");
  else strcpy(pp,"AM");
if(((convert > 13)||((convert % 2) == 0))&&(hour > 12))
  {
  hour = hour - 12;
  }
j = stci_d(&hs[0],hour,4);
if(j == 1)
  {
  hs[2] = '\0';
  hs[1] = hs[0];
  hs[0] = '0';
  }
/* convert minutes */
j = stci_d(&ms[0],minute,4);
if(j == 1)
  {
  ms[2] = '\0';
  ms[1] = ms[0];
  ms[0] = '0';
  }
/* convert seconds */
j = stci_d(&ss[0],sec,4);
if(j == 1)
  {
  ss[2] = '\0';
  ss[1] = ss[0];
  ss[0] = '0';
  }
/* convert decimal seconds */
j = stci_d(&ds[0],dec,4);
if(j == 1)
  {
  ds[2] = '\0';
  ds[1] = ds[0];
  ds[0] = '0';
  }
/* put parts together */
out[0] = '\0';
strcat(out,hs);
if(((convert > 6)&&(convert < 15))||(convert > 17)&&(convert < 22))
                  colon = 'y';
  else colon = 'n';
if(colon == 'y') strcat(out,":");
strcat(out,ms);
if((convert != 1)&&(convert != 2)&&(convert != 7)&&(convert != 8)
  &&(convert != 15)&&(convert != 18))
  {
  if(colon == 'y') strcat(out,":");
  strcat(out,ss);
  }
if((convert == 5)||(convert == 6)||(convert == 11)||(convert == 12)
  ||(convert == 13)||(convert == 14)||(convert == 17)||
    (convert == 20)||(convert == 21))
  {
  if((convert == 11)||(convert == 12)||(convert == 20))
    {
    strcat(out,":");
    }
  if((convert == 13)||(convert == 14)||(convert == 21))
    {
    strcat(out,".");
    }
  strcat(out,ds);
  }
if(convert > 14)
  {
  strcat(out," ");
  strcat(out,pp);
  }
return(0);
}
